#! /bin/awk -f
#################################################################################################
#  Copyright  Spider Financial Corp - All rights reserved.
#  Unauthorized copying of this file, via any medium is strictly prohibited
#   Proprietary and confidential
#  
#  $Revision: 15737 $
#  $Date: 2016-08-11 09:37:18 -0500 (Thu, 11 Aug 2016) $
#  $Author: mohamad $
#  $Id: readini.awk 15737 2016-08-11 14:37:18Z mohamad $ 
#################################################################################################

BEGIN   {
  FS="=";
  IGNORECASE = 1
  mySection="";
  # allow leading and trailing spaces
  SecRegex ="^\\w*\\[" SECTION "\\]\\w*$";
  EntryRegex ="^\\w*" ENTRY "\\w*=\\w*(.*)$";
}

$0 ~ SecRegex {
  mySection = SECTION;
  # don't process any more patterns, goto next line
  next;
}

$0 ~ EntryRegex{
  if ( length(mySection) > 0)
  {
    # match the part on the right of the equal sign
    split($0, fields, "=");

    # trim blanks in front and end of the line
    print trim(fields[2]);
    exit 0;
  }
}

/^\w*\[.*\]\w*$/  {
  # we started another section
  mySection="";
}





function trim(myStr)
{
  gsub(/^[ \t]+|[ \t]+$/, "",myStr);
  return myStr;
}

function trimBrackets(myStr)
{
  gsub(/^\[/, "",myStr);
  gsub(/\]$/, "",myStr);
  return myStr;
}