@echo off&setlocal enableextensions EnableDelayedExpansion
@rem  #####################################################################################################
@rem  Copyright  Spider Financial Corp - All rights reserved.
@rem  Unauthorized copying of this file, via any medium is strictly prohibited
@rem   Proprietary and confidential
@rem  
@rem  $Revision: 16978 $
@rem  $Date: 2020-08-04 13:51:18 -0500 (Tue, 04 Aug 2020) $
@rem  $Author: mohamad $
@rem  $Id: runX12Model.cmd 16978 2020-08-04 18:51:18Z mohamad $ 
@rem    
@rem  #####################################################################################################

:: we expect the model identifier as the 1st argument
if "%1" == "" goto error
set MODEL=%1

:: (1) Initialize the environment
call "%~dp0setenv.cmd" %MODEL%

:: (2) Does the folder exists?
cd %~dp0
if not exist "%MODEL%"        goto filesystem_error
if not exist "%SCRIPTS_DIR%"  goto config_error

::(3) run the program
cd "%~dp0%MODEL%"

SET SPCFILE=%MODEL%.spc
SET DATFILE=Data.dat
SET OUTFILE=%MODEL%.out

IF NOT EXIST %SPCFILE%  GOTO error
IF NOT EXIST %DATFILE% 	GOTO error


IF EXIST "%OUTFILE%" (
	FOR /F %%i IN ('DIR /B /O:D %SPCFILE% %DATFILE% %OUTFILE%') DO SET NEWEST=%%i
	IF NOT "!NEWEST!" == "%OUTFILE%" (%X12A_PROG% -P -Q -W -A -I ".\%MODEL%" -N )
) ELSE (
	:: This is the main program - prepare the spc file, prepare regressors, run the file
	%X12A_PROG% -P -Q -W -A -I ".\%MODEL%" -N
)

:: wait for the program to finish (generates %MODEL%.err file)

goto end

:error
echo missing argument!
echo usage  runX12Model model
goto end

:config_error
echo invalid configuration detected
echo usage  setevnv.cmd model
goto end

:filesystem_error
echo error occured when we attempted to create a subsirectory: %MODEL%
echo usage  setevnv.cmd model


:end

endlocal&goto :eof

