@echo off&setlocal enableextensions
@rem  #####################################################################################################
@rem  Copyright  Spider Financial Corp - All rights reserved.
@rem  Unauthorized copying of this file, via any medium is strictly prohibited
@rem   Proprietary and confidential
@rem  
@rem  $Revision: 15921 $
@rem  $Date: 2016-09-19 16:58:36 -0500 (Mon, 19 Sep 2016) $
@rem  $Author: mohamad $
@rem  $Id: runX13Model.cmd 15921 2016-09-19 21:58:36Z mohamad $ 
@rem    
@rem  #####################################################################################################

:: we expect the model identifier as the 1st argument
if "%1" == "" goto error
set MODEL=%1

:: (1) Initialize the environment
call "%~dp0setenv.cmd" %MODEL%

:: (2) Does the folder exists?
cd %~dp0
if not exist "%MODEL%"        goto filesystem_error
if not exist "%SCRIPTS_DIR%"  goto config_error

::(3) run the program
cd "%~dp0%MODEL%"

if not exist "%MODEL%.spc"     goto error
if not exist "Data.dat"        goto error

:: This is the main program - prepare the spc file, prepare regressors, run the fule
%X13AS_PROG% -P -W -Q -N -I ".\%MODEL%" 


:: wait for the program to finish (generates %MODEL%.err file)


goto end

:error
echo missing argument!
echo usage  runX12Model model
goto end

:config_error
echo invalid configuration detected
echo usage  setevnv.cmd model
goto end

:filesystem_error
echo error occured when we attempted to create a subsirectory: %MODEL%
echo usage  setevnv.cmd model


:end

endlocal&goto :eof

