@echo off&setlocal enableextensions EnableDelayedExpansion
@rem  #####################################################################################################
@rem  Copyright  Spider Financial Corp - All rights reserved.
@rem  Unauthorized copying of this file, via any medium is strictly prohibited
@rem   Proprietary and confidential
@rem  
@rem  $Revision: 16978 $
@rem  $Date: 2020-08-04 13:51:18 -0500 (Tue, 04 Aug 2020) $
@rem  #####################################################################################################

:: we expect the model identifer as the 1st argument
if "%1" == "" goto error
set MODEL=%1

:: does the folder exist?
if not exist "%~dp0%MODEL%" goto error


:: (2) Initialize the environment
call "%~dp0setenv.cmd" %MODEL%

:: (3) Check if options.ini exist
set MODEL_PATH=%~dp0%MODEL%
cd %MODEL_PATH%

SET SPCFILE=%MODEL%.spc
SET INIFILE=options.ini

IF NOT EXIST %INIFILE% goto config_error

:: (3.1) remove all old model output files
IF NOT EXIST %SPCFILE%  goto ini

FOR /F %%i IN ('DIR /B /O:D %SPCFILE% %INIFILE%') DO SET NEWEST=%%i
IF "!NEWEST!" == "%SPCFILE%" goto end

:: del %MODEL%.*
:ini
:: (4) do we have a [data] section
call :isIniSection  %INIFILE% data dataSecExist

if %dataSecExist% == 0  ( 
  @echo missing data section
  goto end
)

:: (5) read the following from this section
:: file=airline.dat
set DATAFILE=""
call :getIniValue %INIFILE% file data DATAFILE
if %DATAFILE% == "" (
  @echo missing [data]-->file entry in the ini file
  goto end
)

if not exist %DATAFILE% (
  @echo specified data file does not exist
  goto end
)

@echo "s|\[data_file\]|%DATAFILE%|g" | %SED_PROG% -e "s|""||g" > options.sed


:: start=1949.1
set STARTDATE=""
call :getIniValue %INIFILE% start data STARTDATE
if %STARTDATE% == "" (
  @echo missing [data]-->start entry in the ini file
  goto end
)
@echo "s|\[data_start\]|%STARTDATE%|g " | %SED_PROG% -e "s|""||g" >> options.sed


:: end=1954.12
set ENDDATE=""
call :getIniValue %INIFILE% end data ENDDATE
if %ENDDATE% == "" (
  @echo missing [data]-->end entry in the ini file
  goto end
)
@echo "s|\[data_end\]|%ENDDATE%|g " | %SED_PROG% -e "s|""||g" >> options.sed


:: period=12
set PERIOD=""
call :getIniValue %INIFILE% period data PERIOD
if %PERIOD%=="" (
  @echo missing [data]-->period entry in the ini file
  goto end
)
@echo "s|\[data_period\]|%PERIOD%|g " | %SED_PROG% -e "s|""||g" >> options.sed

:: stock=0
set ISSTOCK=""
call :getIniValue %INIFILE% stock data ISSTOCK
if %ISSTOCK% == "" (
  @echo missing [data]-->period entry in the ini file
  goto end
)
@echo "s|\[data_isstock\]|%ISSTOCK%|g " | %SED_PROG% -e "s|""||g" >> options.sed


:: we can write the data section in the spc file
:: @echo %DATAFILE% %STARTDATE% %ENDDATE% %PERIOD% %ISSTOCK%

@echo --- Data file section: write to  %MODEL%.spc ------
%SED_PROG% -f options.sed "%TEMPLATES_DIR%\series.tpl" | %SED_PROG% -f "%SCRIPTS_DIR%\def_dynamic.sed" | %SED_PROG% -f options.sed | %SED_PROG% -f "%SCRIPTS_DIR%\def_static.sed" > %MODEL%.spc


:xform
:: (6) read the following from this section transform
set SecExist=0
call :isIniSection  %INIFILE% xform SecExist

if %SecExist% == 0  ( 
  :: skip to the next section
  goto outlier
)

set ENTRY_VAL=""
call :getIniValue %INIFILE% function xform ENTRY_VAL
if ENTRY_VAL% == "" (
  @echo missing [xform]-->function entry in the ini file
  goto end
)
:: Add it to our user options.sed
@echo "s|\[transform_func\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed

@echo --- Data transform: write to  %MODEL%.spc ------
%SED_PROG% -f options.sed "%TEMPLATES_DIR%\transform.tpl" | %SED_PROG% -f "%SCRIPTS_DIR%\def_dynamic.sed" | %SED_PROG% -f options.sed | %SED_PROG% -f "%SCRIPTS_DIR%\def_static.sed" >> %MODEL%.spc


:outlier
:: (7) read the following from this section transform
set SecExist=0
call :isIniSection  %INIFILE% outlier SecExist
if %SecExist% == 0  ( 
  :: skip to the next section
  goto aictest
)


:: AO outlier
set ENTRY_VAL=""
call :getIniValue %INIFILE% ao outlier ENTRY_VAL

if %ENTRY_VAL% == 0 (
  set ENTRY_VAL=""
)

if %ENTRY_VAL% == 1 (
  set ENTRY_VAL="ao"
)


:: Add it to our user options.sed
@echo "s|\[outlier_test_ao\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g"  >> options.sed  

:: TC
set ENTRY_VAL=""
call :getIniValue %INIFILE% tc outlier ENTRY_VAL
if %ENTRY_VAL% == 0 (
  set ENTRY_VAL=""
)

if %ENTRY_VAL% == 1 (
  set ENTRY_VAL="tc"
)

:: Add it to our user options.sed
@echo "s|\[outlier_test_tc\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  


:: LS
set ENTRY_VAL=""
call :getIniValue %INIFILE% ls outlier ENTRY_VAL
if %ENTRY_VAL% == 0 (
  set ENTRY_VAL=""
)

if %ENTRY_VAL% == 1 (
  set ENTRY_VAL="ls"
)
:: Add it to our user options.sed
@echo "s|\[outlier_test_ls\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  


:: do we need an LS run
if "%ENTRY_VAL%" == "" goto aictest

:: LS
set ENTRY_VAL=""
call :getIniValue %INIFILE% lsrun outlier ENTRY_VAL
if %ENTRY_VAL% == "" (
  @echo missing [outlier]-->lsrun entry in the ini file
  goto end
)

:: Add it to our user options.sed
@echo "s|\[outlier_test_lsrun\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  


@echo --- Outliers adjustment: write to  %MODEL%.spc ------
%SED_PROG% -f options.sed "%TEMPLATES_DIR%\outlier.tpl" | %SED_PROG% -f "%SCRIPTS_DIR%\def_dynamic.sed" | %SED_PROG% -f options.sed | %SED_PROG% -f "%SCRIPTS_DIR%\def_static.sed" >> %MODEL%.spc



:aictest
:: (9) read the following from this section aictest
set SecExist=0
call :isIniSection  %INIFILE% aictest SecExist
if %SecExist% == 0  ( 
  :: skip to the next section
  goto regression
)

:: td
set ENTRY_VAL=""
call :getIniValue %INIFILE% td aictest ENTRY_VAL

if %ENTRY_VAL% == 0 (
  set ENTRY_VAL=""
)

if %ENTRY_VAL% == 1 (
  set ENTRY_VAL="td"
)
@echo "s|\[aictest_td\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  

:: Easter
set ENTRY_VAL=""
call :getIniValue %INIFILE% easter aictest ENTRY_VAL

if %ENTRY_VAL% == 0 (
  set ENTRY_VAL=""
)

if %ENTRY_VAL% == 1 (
  set ENTRY_VAL="easter"
)
@echo "s|\[aictest_easter\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  


:regression
:: (10) read the following from this section aictest
set SecExist=0
call :isIniSection  %INIFILE% regression SecExist
if %SecExist% == 0  ( 
  :: skip to the next section
  goto arima
)

:: td
set ENTRY_VAL=""
call :getIniValue %INIFILE% td regression ENTRY_VAL

if %ENTRY_VAL% == 0 (
  set ENTRY_VAL=""
)

if %ENTRY_VAL% == 1 (
  set ENTRY_VAL="td"
)
@echo "s|\[regression_td\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  


:: easter
set ENTRY_VAL=""
call :getIniValue %INIFILE% easter regression ENTRY_VAL

if %ENTRY_VAL% == 0 (
  set ENTRY_VAL=""
)

if %ENTRY_VAL% == 1 (
  set ENTRY_VAL="easter\[14\]"
)
@echo "s|\[regression_easter\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  


:: constant
set ENTRY_VAL=""
call :getIniValue %INIFILE% const regression ENTRY_VAL

if %ENTRY_VAL% == 0 (
  set ENTRY_VAL=""
)

if %ENTRY_VAL% == 1 (
  set ENTRY_VAL="const"
)
@echo "s|\[regression_const\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  


:: Add it to our user options.sed
@echo --- Holidays and calendar adjustment: write to  %MODEL%.spc ------
%SED_PROG% -f options.sed "%TEMPLATES_DIR%\regression.tpl" | %SED_PROG% -f "%SCRIPTS_DIR%\def_dynamic.sed" | %SED_PROG% -f options.sed | %SED_PROG% -f "%SCRIPTS_DIR%\def_static.sed" >> %MODEL%.spc


:arima
:: read theautomdl max orders first
set SecExist=0
call :isIniSection  %INIFILE% automdl SecExist
if %SecExist% == 0  ( 
  :: skip to the next section
  goto arima_selection
)

:: read the max_ar
set ENTRY_VAL=""
call :getIniValue %INIFILE% max_ar automdl ENTRY_VAL
if %ENTRY_VAL% lss 0 (
  goto arima_selection
)
@echo "s|\[automdl_maxar\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  

:: read the max_ma
set ENTRY_VAL=""
call :getIniValue %INIFILE% max_ma automdl ENTRY_VAL
if %ENTRY_VAL% lss 0 (
  goto arima_selection
)
@echo "s|\[automdl_maxma\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  

:: read the max_d
set ENTRY_VAL=""
call :getIniValue %INIFILE% max_d automdl ENTRY_VAL
if %ENTRY_VAL% lss 0 (
  goto arima_selection
)
@echo "s|\[automdl_maxd\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  

:: read the max_dd
set ENTRY_VAL=""
call :getIniValue %INIFILE% max_dd automdl ENTRY_VAL
if %ENTRY_VAL% lss 0 (
  goto arima_selection
)
@echo "s|\[automdl_maxdd\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  

:arima_selection
:: (10) read the following from this section arima
set SecExist=0
call :isIniSection  %INIFILE% arima SecExist
if %SecExist% == 0  ( 
  :: skip to the next section
  goto forecast
)


:: read the auto-select portion
set ENTRY_VAL=""
call :getIniValue %INIFILE% auto arima ENTRY_VAL

if %ENTRY_VAL% == 0 (
  goto manual_arima
)

: not much to do here
:: Add it to our user options.sed
@echo --- RegARIMA Automdl: write to  %MODEL%.spc ------
%SED_PROG% -f options.sed "%TEMPLATES_DIR%\automdl.tpl" | %SED_PROG% -f "%SCRIPTS_DIR%\def_dynamic.sed" | %SED_PROG% -f options.sed | %SED_PROG% -f "%SCRIPTS_DIR%\def_static.sed" >> %MODEL%.spc

goto forecast

:manual_arima
set ENTRY_VAL=""
call :getIniValue %INIFILE% p arima ENTRY_VAL
@echo "s|\[arima_p\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  

set ENTRY_VAL=""
call :getIniValue %INIFILE% q arima ENTRY_VAL
@echo "s|\[arima_q\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  

set ENTRY_VAL=""
call :getIniValue %INIFILE% d arima ENTRY_VAL
@echo "s|\[arima_d\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  

set ENTRY_VAL=""
call :getIniValue %INIFILE% pp arima ENTRY_VAL
@echo "s|\[arima_pp\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  

set ENTRY_VAL=""
call :getIniValue %INIFILE% dd arima ENTRY_VAL
@echo "s|\[arima_dd\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  

set ENTRY_VAL=""
call :getIniValue %INIFILE% qq arima ENTRY_VAL
@echo "s|\[arima_qq\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  


:: not much to do here
:: Add it to our user options.sed
@echo --- manual_arima: write to %MODEL%.spc ------
%SED_PROG% -f options.sed "%TEMPLATES_DIR%\arima.tpl" | %SED_PROG% -f "%SCRIPTS_DIR%\def_dynamic.sed" | %SED_PROG% -f options.sed | %SED_PROG% -f "%SCRIPTS_DIR%\def_static.sed" >> %MODEL%.spc


:forecast
set SecExist=0
call :isIniSection  %INIFILE% forecast SecExist
if %SecExist% == 0  ( 
  :: skip to the next section
  goto saadj
)

set ENTRY_VAL=""
call :getIniValue %INIFILE% horizon forecast ENTRY_VAL
if "%ENTRY_VAL%" == "" (
  @echo missing [forecast]-->horizon from options.ini
  goto end
)
@echo "s|\[forecast_steps\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  

set ENTRY_VAL=""
call :getIniValue %INIFILE% alpha forecast ENTRY_VAL
if "%ENTRY_VAL%" == "" (
  set ENTRY_VAL=5
)

:: compute the probability
set /A ENTRY_VAL = (100 - %ENTRY_VAL%)
:: @echo 0.%ENTRY_VAL%

@echo "s|\[forecast_probability\]|0.%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  

:: Add it to our user options.sed
@echo --- forecast : write to %MODEL%.spc ------
%SED_PROG% -f options.sed "%TEMPLATES_DIR%\forecast.tpl" | %SED_PROG% -f "%SCRIPTS_DIR%\def_dynamic.sed" | %SED_PROG% -f options.sed | %SED_PROG% -f "%SCRIPTS_DIR%\def_static.sed" >> %MODEL%.spc


:saadj
set SecExist=0
call :isIniSection  %INIFILE% saadj SecExist
if %SecExist% == 0  ( 
  :: we are done
  goto end
)

set ENTRY_VAL=""
call :getIniValue %INIFILE% filter saadj ENTRY_VAL

:: we are currently support X11 filter
if not "%ENTRY_VAL%" =="X11" goto end


:x11filter
set SecExist=0
call :isIniSection  %INIFILE% X11 SecExist
if %SecExist% == 0  ( 
  :: we are done
  @echo error : we are missing X11 section
  goto end
)

set ENTRY_VAL=""
call :getIniValue %INIFILE% mode X11 ENTRY_VAL

if "%ENTRY_VAL%" == "" (
  set ENTRY_VAL="mult"
)

@echo "s|\[x11_mode\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  


set ENTRY_VAL=""
call :getIniValue %INIFILE% sma X11 ENTRY_VAL

if "%ENTRY_VAL%" == "" (
  set ENTRY_VAL="X11default"
)
@echo "s|\[x11_sma\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  


set ENTRY_VAL=""
call :getIniValue %INIFILE% henderson X11 ENTRY_VAL

if "%ENTRY_VAL%" == "" (
  set ENTRY_VAL="13"
)
@echo "s|\[x11_trndma\]|%ENTRY_VAL%|g " | %SED_PROG% -e "s|""||g" >> options.sed  

:: Add it to our user options.sed
@echo --- X11 seasonal adjustment : write to %MODEL%.spc ------
%SED_PROG% -f options.sed "%TEMPLATES_DIR%\X11.tpl" | %SED_PROG% -f "%SCRIPTS_DIR%\def_dynamic.sed" | %SED_PROG% -f options.sed | %SED_PROG% -f "%SCRIPTS_DIR%\def_static.sed" >> %MODEL%.spc


goto end

:error
echo missing argument!
echo usage  writeSPCFile
goto end

:config_error
echo Missing options.ini file, file must exists first

:end


endlocal&goto :eof


:getIniValue
rem This function reads a value from an INI file and stored it in a variable
rem %1 = name of ini file to search in.
rem %2 = search term to look for
rem %3 = group name
rem %4 = variable to place search result
setlocal ENABLEEXTENSIONS
%AWK_PROG% -f "%SCRIPTS_DIR%\readini.awk" -v SECTION=%3 -v ENTRY=%2 %1  > filename.txt
set /p res=<filename.txt
endlocal&set %4=%res%&goto:eof


:isIniSection
rem This function reads a value from an INI file and stored it in a variable
rem %1 = name of ini file to search in.
rem %2 = group name (not currently used)
rem %3 = variable to place search result
setlocal ENABLEEXTENSIONS

set pattern="^\w*\[\w*%2\w*\]\w*$"
%GREP_PROG% -e %pattern% --count < %1 > data.sec
set /p res=<data.sec
endlocal&set %3=%res%&goto:eof
